import { ILifetime } from '../Lifetime';
import { IServiceProvider } from '../ServiceProvider';
import { MockStrategy, ProviderMock } from './mockUtils';
import { DependencyMap, Selector } from './types';
export declare class ServiceCollection<E = {}> {
    private readonly self;
    private readonly lifetimes;
    constructor();
    addMethod<F>(func: (services: ServiceCollection<E>) => ServiceCollection<F>): ServiceCollection<F>;
    add<KT, F extends DependencyMap<E, KT>>(dependencies: F & DependencyMap<E, KT>): ServiceCollection<{ [key in keyof KT | keyof E]: key extends keyof E ? E[key] : key extends keyof KT ? KT[key] : never; }>;
    get<T>(selector: Selector<T, E>): ILifetime<T, E> | undefined;
    remove<T, K extends string>(selector: Selector<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof Omit<E, K>]: key extends keyof E ? E[key] : T; }]: { [key in keyof Omit<E, K>]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    build(): IServiceProvider<E>;
    buildMock(mock?: MockStrategy | ProviderMock<E>, defaultMockType?: MockStrategy): IServiceProvider<E>;
}
